Imports System
Imports System.IO

Namespace BuisnessLogicLayer

    Public Class ExportToStamp
        Dim fw As StreamWriter

        Private _fileLocation As String
        Private _eepromTable As String


        Public Sub New()
            'default
        End Sub


        Public Property FileLocation() As String
            Get
                Return _fileLocation
            End Get
            Set(ByVal value As String)
                _fileLocation = value
            End Set
        End Property

        Public Property EepromTable() As String
            Get
                Return _eepromTable
            End Get
            Set(ByVal value As String)
                _eepromTable = value
            End Set
        End Property


        'Public Sub WriteFile()
        '  Dim file As System.IO.StreamWriter
        '  file = My.Computer.FileSystem.OpenTextFileWriter("c:\test.txt", True)
        '  file.WriteLine("Here is the first string.")
        '  file.Close()
        'End Sub


        'Public Sub ReadFile()
        '  Dim fileReader As String
        '  fileReader = My.Computer.FileSystem.ReadAllText("C:\test.txt")
        '  MsgBox(fileReader)
        'End Sub

        Public Function CreateExport(ByVal file As String) As String
            'Dim ReadString As String
            Try
                fw = New StreamWriter(file, False)
                fw = WriteHeader(fw)
                fw = WriteEeprom(fw)
                fw = WriteBody(fw)
                'ReadString = Entry.Text
                'fw.WriteLine(ReadString)
            Finally
                'Close the file.
                fw.Close()
            End Try

            Return "Done"
        End Function

        Private Function WriteHeader(ByVal fileStream As StreamWriter) As StreamWriter
            Dim fs As StreamWriter = fileStream

            fs.WriteLine("' {$STAMP BS2p} ")
            fs.WriteLine("' {$PBASIC 2.5} ")
            fs.WriteLine("'Created " & Date.Today & " by CrustCrawler.com automation - MG ;)~ ")
            fs.WriteLine()
            fs.WriteLine("' Set baud for all STAMP versions")
            fs.WriteLine("#SELECT $STAMP")
            fs.WriteLine("  #CASE BS2SX, BS2P ")
            fs.WriteLine("    N2400        CON     1021 + $8000 ")
            fs.WriteLine("    N38K4        CON     45 + $8000 ")
            fs.WriteLine("  #CASE BS2PX")
            fs.WriteLine("    N2400        CON     1646 + $8000")
            fs.WriteLine("    N38K4        CON     84 + $8000")
            fs.WriteLine("  #CASE #ELSE")
            fs.WriteLine("    N2400        CON     396 + $8000")
            fs.WriteLine("    N38K4        CON     6 + $8000")
            fs.WriteLine("#ENDSELECT")
            fs.WriteLine()
            fs.WriteLine("'---- [Constants] -------------------------------------------------------- ")
            fs.WriteLine("PSC              CON     15                     ' PSC I/O Pin  ")
            fs.WriteLine("BaudSetting      CON     0                      ' 0 = N2400; 1 = N38K4")
            fs.WriteLine("Repeat           CON     1                      ' Repeat ")
            fs.WriteLine("Columns          CON     5                      ' Columns")
            fs.WriteLine("GroupDelay       CON     $FE                    ' Group Delay")
            fs.WriteLine("EepromEnd        CON     $FF                    ' End of EEPROM ")
            fs.WriteLine()
            fs.WriteLine("'---- [Variables] --------------------------------------------------------")
            fs.WriteLine("ptrEEPROM        VAR     Word                   ' EEPROM Pointer")
            fs.WriteLine("temp             VAR     Word                   ' Workspace var")
            fs.WriteLine("baud             VAR     Word                   ' Baud ")
            fs.WriteLine("buff             VAR     Byte(5)                ' Temporary variable")
            fs.WriteLine()
            fs.WriteLine("'----[ EEPROM ]----------------------------------------------------------- ")
            fs.WriteLine("'ch, rp, lp, hp, dy ")
            Return fs
        End Function

        Private Function WriteEeprom(ByVal fileStream As StreamWriter) As StreamWriter
            Dim fs As StreamWriter = fileStream
            fs.WriteLine(_eepromTable & String.Format("{0}{0}{0}{0}{0}{0}$FF", vbTab))

            'Sample Eeprom Table
            'fs.WriteLine("Start DATA $01, $07, $F4, $01, $01,")
            'fs.WriteLine("           $02, $07, $F4, $01, $01,")
            'fs.WriteLine("           $FE, $88, $13, $FF, $FF,")
            'fs.WriteLine("           $01, $07, $E8, $03, $01,")
            'fs.WriteLine("           $02, $07, $E8, $03, $01,")
            'fs.WriteLine("           $FE, $E8, $03, $FF, $FF,")
            'fs.WriteLine("           $03, $07, $E8, $03, $01,")
            'fs.WriteLine("           $00, $07, $E8, $03, $01,")
            'fs.WriteLine("           $FE, $E8, $03, $FF, $FF,")
            'fs.WriteLine("           $03, $07, $F4, $01, $01,")
            'fs.WriteLine("           $00, $07, $F4, $01, $01,")
            'fs.WriteLine("           $FE, $88, $13, $FF, $FF,")
            'fs.WriteLine("           $FF")
            fs.WriteLine()
            Return fs
        End Function

        Private Function WriteBody(ByVal fileStream As StreamWriter) As StreamWriter
            Dim fs As StreamWriter = fileStream
            fs.WriteLine("  ' 0 = normal mode")
            fs.WriteLine("  ' 1 = debug mode")
            fs.WriteLine("  #DEFINE debugMode = 0")
            fs.WriteLine("Init:")
            fs.WriteLine("  IF BaudSetting THEN")
            fs.WriteLine("    GOSUB Force_N38K4")
            fs.WriteLine("  ELSE ")
            fs.WriteLine("    GOSUB Force_N2400")
            fs.WriteLine("  ENDIF")
            fs.WriteLine()
            fs.WriteLine("  PAUSE 2000")
            fs.WriteLine("Main:")
            fs.WriteLine("  'Read EEPROM ")
            fs.WriteLine("  READ ptrEEPROM, buff(0) ,buff(1), buff(2), buff(3), buff(4)")
            fs.WriteLine()
            fs.WriteLine("    'DEBUG Tool")
            fs.WriteLine("    #IF debugMode #THEN")
            fs.WriteLine("      GOSUB Trace")
            fs.WriteLine("    #ENDIF")
            fs.WriteLine()
            fs.WriteLine("  'Check first byt")
            fs.WriteLine("  IF buff(0) = $FF THEN Repeater")
            fs.WriteLine()
            fs.WriteLine("  IF buff(0) = $FE THEN ")
            fs.WriteLine("    GOSUB GroupWait")
            fs.WriteLine("  ENDIF ")
            fs.WriteLine()
            fs.WriteLine("  ' Write servo postion to PSC")
            fs.WriteLine("  GOSUB Write_PSC")
            fs.WriteLine()
            fs.WriteLine("  'Increment pointer")
            fs.WriteLine("  ptrEEPROM = ptrEEPROM + Columns ")
            fs.WriteLine()
            fs.WriteLine("GOTO Main")
            fs.WriteLine("END ")
            fs.WriteLine()
            fs.WriteLine("'_________________________________________________________________________")
            fs.WriteLine()
            fs.WriteLine("'/////////////////////////////////////////////////////////////////////////")
            fs.WriteLine("' Write position commands to the PSC")
            fs.WriteLine()
            fs.WriteLine("' Parameters (ServoAddr, servoPosition, delay)")
            fs.WriteLine("' Return Nothing")
            fs.WriteLine("'/////////////////////////////////////////////////////////////////////////")
            fs.WriteLine("Write_PSC:")
            fs.WriteLine("  SEROUT PSC,baud,[""!SC"", buff(0), buff(1), buff(2), buff(3), CR]")
            fs.WriteLine("  PAUSE buff(4)")
            fs.WriteLine("RETURN")
            fs.WriteLine()
            fs.WriteLine("'_________________________________________________________________________")
            fs.WriteLine()
            fs.WriteLine("Repeater:")
            fs.WriteLine("  IF repeat THEN")
            fs.WriteLine("    ptrEEPROM = Start")
            fs.WriteLine("      #IF debugMode #THEN ")
            fs.WriteLine("        DEBUG ""Repeater END"", CR")
            fs.WriteLine("      #ENDIF ")
            fs.WriteLine("    GOTO Main")
            fs.WriteLine("  ENDIF")
            fs.WriteLine("END ")
            fs.WriteLine("'_________________________________________________________________________")
            fs.WriteLine()
            fs.WriteLine("GroupWait:")
            fs.WriteLine("  temp.LOWBYTE = buff(1)")
            fs.WriteLine("  temp.HIGHBYTE = buff(2)")
            fs.WriteLine("  PAUSE temp")
            fs.WriteLine("RETURN")
            fs.WriteLine("'_________________________________________________________________________")
            fs.WriteLine()
            fs.WriteLine("Force_N38K4:")
            fs.WriteLine("#IF debugMode #THEN")
            fs.WriteLine("  DEBUG ""Force 38K4"", CR")
            fs.WriteLine("#ENDIF")
            fs.WriteLine("  SEROUT PSC, N38K4, [""!SCVER?"",CR]")
            fs.WriteLine("  SERIN PSC, N38K4, 500, Set_N38K4,[STR buff\3]")
            fs.WriteLine("#IF debugMode #THEN")
            fs.WriteLine("  DEBUG ""38K4 Already Set"",CR")
            fs.WriteLine("#ENDIF")
            fs.WriteLine("  GOTO N38K4_Set")
            fs.WriteLine("Set_N38K4:")
            fs.WriteLine("#IF debugMode #THEN")
            fs.WriteLine("  DEBUG ""Setting to 38K4"", CR ")
            fs.WriteLine("#ENDIF ")
            fs.WriteLine("  SEROUT PSC, N2400,[""!SCSBR"",1,CR]")
            fs.WriteLine("  SERIN PSC, N38K4 ,500, Baud_Exception, [STR buff\3]")
            fs.WriteLine("#IF debugMode #THEN  ")
            fs.WriteLine("  DEBUG ""Baud set to 38K4"", CR, ""PSC reply:  "",")
            fs.WriteLine("  buff(0), buff(1), DEC buff(2), CR")
            fs.WriteLine("#ENDIF")
            fs.WriteLine()
            fs.WriteLine("N38K4_Set:")
            fs.WriteLine("  baud = N38K4 ")
            fs.WriteLine("RETURN ")
            fs.WriteLine("'_________________________________________________________________________")
            fs.WriteLine()
            fs.WriteLine("Force_N2400:")
            fs.WriteLine("#IF debugMode #THEN")
            fs.WriteLine("  DEBUG ""Force N2400"", CR ")
            fs.WriteLine("#ENDIF")
            fs.WriteLine("  SEROUT PSC, N2400, [""!SCVER?"",CR]")
            fs.WriteLine("  SERIN PSC, N2400, 500, Set_N2400,[STR buff\3]")
            fs.WriteLine("#IF debugMode #THEN")
            fs.WriteLine("  DEBUG ""N2400 Already Set"",CR")
            fs.WriteLine("#ENDIF ")
            fs.WriteLine("  GOTO N2400_Set")
            fs.WriteLine("Set_N2400:")
            fs.WriteLine("#IF debugMode #THEN")
            fs.WriteLine("  DEBUG ""Setting to N2400"", CR")
            fs.WriteLine("#ENDIF ")
            fs.WriteLine("  SEROUT PSC, N38K4,[""!SCSBR"",0,CR]")
            fs.WriteLine("  SERIN PSC, N2400 ,500, Baud_Exception, [STR buff\3]")
            fs.WriteLine("#IF debugMode #THEN")
            fs.WriteLine("  DEBUG ""Baud set to N2400"", CR, ""PSC reply:  "", ")
            fs.WriteLine("  buff(0), buff(1), DEC buff(2), CR")
            fs.WriteLine("#ENDIF")
            fs.WriteLine()
            fs.WriteLine("N2400_Set:")
            fs.WriteLine("  baud = N2400")
            fs.WriteLine("RETURN")
            fs.WriteLine("'_________________________________________________________________________")
            fs.WriteLine()
            fs.WriteLine("Baud_Exception:")
            fs.WriteLine("#IF debugMode #THEN")
            fs.WriteLine("  DEBUG ""Failed to set baud"", CR")
            fs.WriteLine("#ENDIF")
            fs.WriteLine("RETURN")
            fs.WriteLine("'_________________________________________________________________________")
            fs.WriteLine()
            fs.WriteLine("' Write trace information")
            fs.WriteLine("'   to debug terminal")
            fs.WriteLine("#IF debugMode #THEN ")
            fs.WriteLine("  Trace:")
            fs.WriteLine("    DEBUG CLS, HEX ?buff(0) ,HEX ?buff(1), HEX ?buff(2), HEX ?buff(3),")
            fs.WriteLine("    HEX ?buff(4), ?baud")
            fs.WriteLine("  RETURN ")
            fs.WriteLine("#ENDIF")
            Return fs
        End Function


        Public Sub AddEepromRow(ByVal channel As Integer, ByVal ramp As Integer, ByVal position As Integer, ByVal delay As Integer)
            Try
                If _eepromTable Is Nothing OrElse _eepromTable.Length = 0 Then
                    _eepromTable += String.Format("{0}  ${1},${2},${3},${4},${5},{6}", "Start DATA", Pad0(Hex(CByte(channel))), Pad0(Hex(CByte(ramp))), Pad0(Hex(CByte((position And &HFF)))), Pad0(Hex(CByte((position And &HFF00) / &H100))), Pad0(Hex(CByte(delay))), vbCrLf)
                Else
                    _eepromTable += String.Format("{0}{0}{0}{0}{0}{0}${1},${2},${3},${4},${5},{6}", vbTab, Pad0(Hex(CByte(channel))), Pad0(Hex(CByte(ramp))), Pad0(Hex(CByte((position And &HFF)))), Pad0(Hex(CByte((position And &HFF00) / &H100))), Pad0(Hex(CByte(delay))), vbCrLf)
                End If
            Catch ex As ArithmeticException
                MessageBox.Show(ex.ToString)
            Catch ex As Exception

            End Try


        End Sub

        Public Sub AddEepromRow(ByVal groupDelay As Integer)
            _eepromTable += String.Format("{0}{0}{0}{0}{0}{0}${1},${2},${3},${4},${5},{6}", vbTab, "FE", Pad0(Hex(CByte((groupDelay And &HFF)))), Pad0(Hex(CByte((groupDelay And &HFF00) / &H100))), "FF", "FF", vbCrLf)
        End Sub

        Private Function Pad0(ByVal str As String) As String
            If str.Length = 1 Then
                str = "0" & str
            End If
            Return str
        End Function


    End Class

End Namespace
