Imports CrustCrawler.BuisnessLogicLayer.ParallaxServoController
Namespace BuisnessLogicLayer

  Public Delegate Sub PositionCommandEventHandler(ByVal sender As Object, ByVal e As PscEventArgs)
  Public Delegate Sub RecordSetEventHandler(ByVal sender As Object, ByVal e As SequenceEventArgs)
  Public Delegate Sub GroupEventHandler(ByVal sender As Object, ByVal e As PscChannelEventArgs)

  Public Class PscEventArgs : Inherits EventArgs

    Private _id As Integer
    Private _max As Integer
    Private _min As Integer
    Private _position As Integer
    Private _ramp As Integer
    Private _delay As Integer



    Public Sub New(ByVal pscObject As PscChannel)
      _id = pscObject.ChannelId
      _max = pscObject.Max
      _min = pscObject.Min
      _position = pscObject.Position
      _ramp = pscObject.Ramp
      _delay = pscObject.Delay
    End Sub


    Public Property Id() As Integer
      Get
        Return _id
      End Get
      Set(ByVal value As Integer)
        _id = value
      End Set
    End Property


    Public Property Max() As Integer
      Get
        Return _max
      End Get
      Set(ByVal value As Integer)
        _max = value
      End Set
    End Property


    Public Property Min() As Integer
      Get
        Return _min
      End Get
      Set(ByVal value As Integer)
        _min = value
      End Set
    End Property


    Public Property Position() As Integer
      Get
        Return _position
      End Get
      Set(ByVal value As Integer)
        _position = value
      End Set
    End Property


    Public Property Ramp() As Integer
      Get
        Return _ramp
      End Get
      Set(ByVal value As Integer)
        _ramp = value
      End Set
    End Property


    Public Property Delay() As Integer
      Get
        Return _delay
      End Get
      Set(ByVal value As Integer)
        _delay = value
      End Set
    End Property


  End Class 'PscEventArguments


  Public Class OffsetArgs : Inherits EventArgs
    Public _oldOffset As Integer
    Public _newOffset As Integer
    Public _diff As Integer
    'Private _position As Integer

    Private _max As Integer
    Private _min As Integer
    Private _position As Integer


    'Public Property OldOffset() As Integer
    '  Get
    '    Return _oldOffset
    '  End Get
    '  Set(ByVal value As Integer)
    '    _oldOffset = value
    '  End Set
    'End Property

    'Public Property NewOffset() As Integer
    '  Get
    '    Return _newOffset
    '  End Get
    '  Set(ByVal value As Integer)
    '    _newOffset = value
    '  End Set
    'End Property

    Public ReadOnly Property Diff() As Integer
      Get
        Return _diff
      End Get
    End Property

    'Public Property Position() As Integer
    '  Get
    '    Return _position
    '  End Get
    '  Set(ByVal value As Integer)
    '    _position = value
    '  End Set
    'End Property


    Public Property Max() As Integer
      Get
        Return _max
      End Get
      Set(ByVal value As Integer)
        _max = value
      End Set
    End Property


    Public Property Min() As Integer
      Get
        Return _min
      End Get
      Set(ByVal value As Integer)
        _min = value
      End Set
    End Property


    Public Property Position() As Integer
      Get
        Return _position
      End Get
      Set(ByVal value As Integer)
        _position = value
      End Set
    End Property



    Public Sub New(ByVal newOffset As Integer, ByVal channel As PeerChannel)
      _newOffset = newOffset
      _oldOffset = channel.Offset
      _diff = _newOffset - _oldOffset
      _max = channel.Max + _diff
      _min = channel.Min + Diff
      _position = channel.position
    End Sub

  End Class



  Public Class SequenceEventArgs : Inherits EventArgs

    Private _sequenceDelay As Integer
    Private _sequenceId As Integer

    Public Property SequenceDelay() As Integer
      Get
        Return _sequenceDelay
      End Get
      Set(ByVal value As Integer)
        _sequenceDelay = value
      End Set
    End Property


    Public Property SequenceId() As Integer
      Get
        Return _sequenceId
      End Get
      Set(ByVal value As Integer)
        _sequenceId = value
      End Set
    End Property



    Public Sub New(ByVal SequenceDelay As Integer)
      _sequenceDelay = SequenceDelay
    End Sub


    Public Sub New(ByVal SequenceDelay As Integer, ByVal SequenceId As Integer)
      _sequenceDelay = SequenceDelay
      _sequenceId = SequenceId
    End Sub



  End Class



  Public Class PscChannelEventArgs : Inherits EventArgs
    Private _channel As String
    Private _channelObject As PscChannel

    'Private _psc As Integer

    Public Sub New(ByVal channel As String)
      MyClass.New(channel, PscChannel.Empty)
      '_channel = channel
      '_psc = Psc
    End Sub

    Public Sub New(ByVal channel As String, ByVal channelObject As PscChannel)
      _channel = channel
      _channelObject = channelObject
    End Sub


    Public Property ChannelObject() As PscChannel
      Get
        Return _channelObject
      End Get
      Set(ByVal value As PscChannel)
        _channelObject = value
      End Set
    End Property


    Public ReadOnly Property Channel(ByVal i As Integer) As String
      Get
        Dim args() As String = Split(_channel, "_")
        Return args(i)
      End Get
    End Property

    'Public ReadOnly Property PSC() As Integer
    '  Get
    '    Return _psc
    '  End Get
    'End Property


  End Class

End Namespace 'BuisnessLogicLayer