﻿Imports CrustCrawler.BuisnessLogicLayer
Imports System.Threading
Imports CrustCrawler.BuisnessLogicLayer.ParallaxServoController
Imports System.Environment
Imports System.ComponentModel


Partial Class Sequence

    Public Event SequenceChanged As EventHandler
    Public Event SortGrid As EventHandler

    Public Event RecordChanged As RecordSetEventHandler
    Public Event HighLightRow As RecordSetEventHandler



    Public Function Add(ByVal Delay As Integer, ByVal ch As List(Of PscChannel)) As Integer
        Try
            'Dim seq As Integer = ArmPositions.Rows.Count + 1
            Dim SeqID As Integer = NewArmPostion(Delay)
            Dim i As Integer = 0
            For Each c As PscChannel In ch
                NewJointPosition(SeqID, i, c)
                i += 1
            Next
        Catch ex As Exception
            Throw New Exception(ex.ToString)
        End Try
        OnSequenceChanged(EventArgs.Empty)
        OnSortGrid(EventArgs.Empty)
    End Function


    Public Function ExecuteSequence(ByVal sequenceString As String, ByRef ch As List(Of PscChannel), ByVal bw As BackgroundWorker) As Integer
        Dim records As New List(Of Integer)
        Try
            If sequenceString = Nothing OrElse sequenceString.Length = 0 Then
                sequenceString = "1-" & Me.ArmPositions.Count
            End If

            records = SplitSequenceString(sequenceString)
            For Each record As Integer In records
                Dim newArmPositionRow As Sequence.ArmPositionsRow
                newArmPositionRow = Me.ArmPositions.Item(record)
                Dim e As New SequenceEventArgs(newArmPositionRow.Pause)
                OnRecordChanged(e)
                Dim dRow As Sequence.JointPositionsRow() = newArmPositionRow.GetChildRows("ArmPositions_JointPositions")
                For Each row As Sequence.JointPositionsRow In dRow
                    For Each c As PscChannel In ch
                        If row.Channel = c.ChannelId Then
                            c.position = row.Position
                            c.Ramp = row.Ramp
                            c.Delay = row.Pause
                            Dim se As New SequenceEventArgs(newArmPositionRow.Pause, row.ArmPositionID)
                            OnHighLightRow(se)
                        End If

                    Next

                Next

                'iterate through the channel objects and execute the move method
                For Each c As PscChannel In ch
                    c.move()
                    ' If the operation was canceled by the user, 
                    ' set the DoWorkEventArgs.Cancel property to true.
                    If bw.CancellationPending Then
                        Return 1
                    End If
                Next
                Thread.Sleep(newArmPositionRow.Pause)
            Next
            Return 0
        Catch ex As System.InvalidOperationException
            Throw New System.InvalidOperationException("Error executing sequence", ex)
        Catch ex As Exception
            Throw New Exception("An error condition occurred while executing sequence.")
        End Try

    End Function



    Public Function ExecuteSequence(ByVal sequenceString As String, ByRef ch As List(Of PscChannel)) As Integer
        Dim records As New List(Of Integer)
        Try
            If sequenceString = Nothing OrElse sequenceString.Length = 0 Then
                sequenceString = "1-" & Me.ArmPositions.Count
            End If

            records = SplitSequenceString(sequenceString)
            For Each record As Integer In records
                Dim newArmPositionRow As Sequence.ArmPositionsRow
                newArmPositionRow = Me.ArmPositions.Item(record)
                Dim e As New SequenceEventArgs(newArmPositionRow.Pause)
                OnRecordChanged(e)
                Dim dRow As Sequence.JointPositionsRow() = newArmPositionRow.GetChildRows("ArmPositions_JointPositions")
                For Each row As Sequence.JointPositionsRow In dRow
                    For Each c As PscChannel In ch
                        If c.ChannelId = row.Channel Then
                            c.position = row.Position
                            c.Ramp = row.Ramp
                            c.Delay = row.Pause
                            Dim se As New SequenceEventArgs(newArmPositionRow.Pause, row.ArmPositionID)
                            OnHighLightRow(se)
                        End If
                    Next
                Next
                'iterate through the channel objects and execute the move method
                For Each c As PscChannel In ch
                    c.move()
                Next
                Thread.Sleep(newArmPositionRow.Pause)
            Next
            Return 0
        Catch ex As System.InvalidOperationException
            Throw New System.InvalidOperationException("Error executing sequence", ex)
        Catch ex As Exception
            Throw New Exception("An error condition occurred while executing sequence.")
        End Try

    End Function


    'Hepler function to split sequence string
    Private Function SplitSequenceString(ByVal sequenceString As String) As List(Of Integer)
        Dim recordId As New List(Of Integer)
        Dim buff() As String = sequenceString.Split(",")
        Try
            For Each str As String In buff
                If str.Contains("-") Then
                    Dim rangeBuff() As String = str.Split("-")
                    Dim num1 As Integer = CInt(rangeBuff(0))
                    Dim num2 As Integer = CInt(rangeBuff(1))
                    For i As Integer = num1 To num2
                        recordId.Add(i - 1)
                    Next
                Else
                    recordId.Add(CInt(str - 1))
                End If
            Next
        Catch ex As InvalidCastException
            Throw New InvalidCastException("Invalid sequnce", ex)
        Catch ex As Exception
            Throw New ApplicationException("Error in Sequence.SplitSequenceString", ex)
        End Try
        Return recordId
    End Function


    Private Function GetLastSequence() As Integer
        Return Me.ArmPositions.Count
    End Function


    Public Sub LoadPositions(ByVal RecordNumber As Integer, ByRef ch As List(Of PscChannel))
        Dim newArmPositionRow As Sequence.ArmPositionsRow
        newArmPositionRow = Me.ArmPositions.Item(RecordNumber)
        Dim dRow As Sequence.JointPositionsRow() = newArmPositionRow.GetChildRows("ArmPositions_JointPositions")
        For Each row As Sequence.JointPositionsRow In dRow
            For Each c As PscChannel In ch
                If c.ChannelId = row.Channel Then
                    c.Delay = row.Pause
                    c.Ramp = row.Ramp
                    c.position = row.Position
                End If
            Next
            Dim se As New SequenceEventArgs(newArmPositionRow.Pause, row.ArmPositionID)
            OnHighLightRow(se)
        Next
        For Each c As PscChannel In ch
            c.move()
            Dim e As New SequenceEventArgs(newArmPositionRow.Pause)
            OnRecordChanged(e)
        Next

    End Sub


    Public Function Update(ByVal RecordNumber As Integer, ByVal Delay As Integer, ByVal ch As List(Of PscChannel)) As Boolean
        Dim newArmPositionRow As Sequence.ArmPositionsRow
        newArmPositionRow = Me.ArmPositions.Item(RecordNumber)
        newArmPositionRow.Pause = Delay
        Dim dRow As Sequence.JointPositionsRow() = newArmPositionRow.GetChildRows("ArmPositions_JointPositions")
        'Delete child rows
        For Each row As Sequence.JointPositionsRow In dRow
            row.Delete()
        Next
        'Add new child rows
        Dim i As Integer = 0
        For Each c As PscChannel In ch
            NewJointPosition(newArmPositionRow.ArmPositionID, i, c)
            i += 1
        Next
        OnSortGrid(EventArgs.Empty)
    End Function



    Public Function Delete(ByVal RecordNumber As Integer) As Boolean
        Dim success As Boolean = True

        Dim newArmPositionRow As Sequence.ArmPositionsRow
        newArmPositionRow = Me.ArmPositions.Item(RecordNumber - 1)

        Dim dRow As Sequence.JointPositionsRow() = newArmPositionRow.GetChildRows("ArmPositions_JointPositions")
        For Each row As Sequence.JointPositionsRow In dRow
            row.Delete()
        Next
        newArmPositionRow.Delete()

        OnSequenceChanged(EventArgs.Empty)
        OnSortGrid(EventArgs.Empty)
        Return success

    End Function


    Private Function NewArmPostion(ByVal pause As Integer) As Integer
        Dim newArmPositionRow As Sequence.ArmPositionsRow
        newArmPositionRow = Me.ArmPositions.NewArmPositionsRow
        newArmPositionRow.Pause = pause
        'newArmPositionRow.RowNum = Me.ArmPositions.Count + 1
        Me.ArmPositions.Rows.Add(newArmPositionRow)
        Return newArmPositionRow.ArmPositionID
    End Function


    Public Sub NewJointPosition(ByVal sequenceId As Integer, ByVal index As Integer, ByVal Channel As PscChannel)
        Dim newJointPositionRow As Sequence.JointPositionsRow
        newJointPositionRow = Me.JointPositions.NewJointPositionsRow
        newJointPositionRow.ArmPositionID = sequenceId
        'newJointPositionRow.Index = index
        newJointPositionRow.Channel = Channel.ChannelId
        newJointPositionRow.Ramp = Channel.Ramp
        newJointPositionRow.Position = Channel.position
        newJointPositionRow.Pause = Channel.Delay
        Me.JointPositions.Rows.Add(newJointPositionRow)
    End Sub


    Public Sub WriteToFile(ByVal fileName As String)
        Me.WriteXml(fileName, XmlWriteMode.WriteSchema)
    End Sub


    Public Sub LoadXmlData(ByVal fileName As String)
        If Me IsNot Nothing Then
            Me.Clear()
        End If
        Me.ReadXml(fileName, XmlReadMode.ReadSchema)
        OnSequenceChanged(EventArgs.Empty)
    End Sub


    Public Function ExecuteEepromExport(ByVal sequenceString As String, ByVal pc As List(Of PscChannelControl)) As ExportToStamp
        Dim records As New List(Of Integer)
        Dim eeprom As New ExportToStamp

        If sequenceString = Nothing OrElse sequenceString.Length = 0 Then
            sequenceString = "1-" & Me.ArmPositions.Count
        End If

        records = SplitSequenceString(sequenceString)
        For Each record As Integer In records
            Dim newArmPositionRow As Sequence.ArmPositionsRow
            newArmPositionRow = Me.ArmPositions.Item(record)
            'Get Group Delay
            Dim groupDelay As Integer = CInt(newArmPositionRow.Pause)
            'Get child row
            Dim dRow As Sequence.JointPositionsRow() = newArmPositionRow.GetChildRows("ArmPositions_JointPositions")
            For Each row As Sequence.JointPositionsRow In dRow
                Dim p As Integer = row.Position
                Dim masterInverse As Boolean = False
                For Each c As PscChannelControl In pc
                    If c.DataSource.ChannelId = row.Channel Then
                        If c.DataSource.Inverse Then
                            p = Globals.Inverse(c.DataSource.Max, c.DataSource.Min, p)
                            masterInverse = True
                        End If
                    End If
                Next
                eeprom.AddEepromRow(CInt(row.Channel), CInt(row.Ramp), CInt(p), CInt(row.Pause))
                'Get child data
                For Each c As PscChannelControl In pc
                    If (c.DataSource.ChannelId = row.Channel) And c.DataSource.GetType.Name = "PeerChannel" Then
                        For Each ch As PeerChannel In CType(c.DataSource, PeerChannel).ChildChannels
                            Dim pos As Integer = p + ch.Offset
                            If ch.Inverse Then
                                pos = Globals.Inverse(ch.Max, ch.Min, pos)
                            End If
                            eeprom.AddEepromRow(CInt(ch.ChannelId), CInt(ch.Ramp), CInt(pos), CInt(ch.Delay))
                        Next
                    End If
                Next
            Next
            eeprom.AddEepromRow(groupDelay)
        Next
        Return eeprom

    End Function

    Public Overrides Sub Reset()
        If Me.ArmPositions.Count > 0 Then

            Me.ArmPositions.Clear()
            Me.ArmPositions.Reset()

            Me.JointPositions.Clear()
            Me.JointPositions.Reset()

            Me.EnforceConstraints = True
            Me.SchemaSerializationMode = System.Data.SchemaSerializationMode.IncludeSchema
            Me.tableArmPositions = New ArmPositionsDataTable
            MyBase.Tables.Add(Me.tableArmPositions)
            Me.tableJointPositions = New JointPositionsDataTable
            MyBase.Tables.Add(Me.tableJointPositions)
            Me.relationArmPositions_JointPositions = New System.Data.DataRelation("ArmPositions_JointPositions", New System.Data.DataColumn() {Me.tableArmPositions.ArmPositionIDColumn}, New System.Data.DataColumn() {Me.tableJointPositions.ArmPositionIDColumn}, False)
            Me.relationArmPositions_JointPositions.Nested = True
            Me.Relations.Add(Me.relationArmPositions_JointPositions)
        End If
    End Sub





    Public Sub OnSequenceChanged(ByVal e As EventArgs)
        RaiseEvent SequenceChanged(Me, e)
    End Sub

    Private Sub OnRecordChanged(ByVal e As SequenceEventArgs)
        RaiseEvent RecordChanged(Me, e)
    End Sub

    Private Sub OnHighLightRow(ByVal e As SequenceEventArgs)
        RaiseEvent HighLightRow(Me, e)
    End Sub

    Private Sub OnSortGrid(ByVal e As EventArgs)
        RaiseEvent SortGrid(Me, e)
    End Sub



End Class 'Sequence









