Imports CrustCrawler.BuisnessLogicLayer
Imports CrustCrawler.BuisnessLogicLayer.ParallaxServoController
Imports System.Threading
Imports System.IO
Imports System.Environment
Imports System.ComponentModel

'TODO: Individual Grouping issues again!!!

Public Class ControlForm

    Dim Psc As List(Of ParallaxServoController) = Nothing
    Dim ICh As IChannel = Nothing
    Dim channelControls As New List(Of PscChannelControl)


    Public Sub New()
        ' This call is required by the Windows Form Designer.
        InitializeComponent()
        ' Add any initialization after the InitializeComponent() call.

        'Find attached PSCs
        GetPSC()
        Thread.Sleep(500)
        'AddTestChannels()
        If Psc.Count > 0 Then
            AddPscToChannelMenuItems(Psc)
            AddPscBaudToPscMenuItems(Psc)
            txtSequenceDelay.Text = "1000"
            'OpenDefaultProject
        End If
    End Sub


    Private Sub OpenDefaultProject()
        'OpenProject("C:\Documents and Settings\Mike Gebhard\Application Data\CrustCrawler\PSC\project.xml")
        'OpenSequence("C:\Documents and Settings\Mike Gebhard\Application Data\CrustCrawler\PSC\sequence1.xml")

        'OpenProject("C:\Documents and Settings\Mike Gebhard\Application Data\CrustCrawler\CPSCI\project.xml")
        'OpenSequence("C:\Documents and Settings\Mike Gebhard\Application Data\CrustCrawler\CPSCI\sequence1.xml")
    End Sub



    Private Sub GetPSC()
        Me.lblComPort.Text = "Searching..."
        Me.StatusStrip1.Update()
        'Find attached PSCs
        Psc = ParallaxServoControllerFactory.GetPSCs
        'Open PSC port
        If Psc.Count > 0 Then
            Me.lblComPort.Text = OpenPscPorts()
        Else
            Me.lblComPort.Text = " PSC Not Found!"
        End If
        Me.StatusStrip1.Update()
    End Sub


    Private Function OpenPscPorts() As String
        Dim str As String = Nothing
        For Each p As ParallaxServoController In Psc
            p.OpenSerialPort()
            str = str & p.ToString
        Next
        Return str
    End Function


    Private Sub CreateChannel(ByVal pscId As Integer, ByVal channelNumber As Integer, ByVal chControl As PscChannelControl)
        Try
            If Not Psc Is Nothing Then
                Dim channel As PscChannel
                channel = Psc(pscId).CreateNewChannel(CInt(channelNumber))
                chControl.BindChannel(channel)
                chControl.BringToFront()
            End If
        Catch ex As Exception
            MessageBox.Show("Error creating channel object " & chControl.ToString)
        End Try
    End Sub 'CreateChannel


    Private Sub CreateChannel(ByVal pscId As Integer, ByVal channel As PscChannel, ByVal chControl As PscChannelControl)
        Try
            If Not Psc Is Nothing Then
                channel = Psc(pscId).CreateNewChannel(channel)
                chControl.BindChannel(channel)
                chControl.BringToFront()
            End If
        Catch ex As Exception
            MessageBox.Show("Error creating channel object " & chControl.ToString)
        End Try
    End Sub


    Private Sub CleanUp()
        Me.lblComPort.Text = "Closing..."
        Me.StatusStrip1.Update()
        Thread.Sleep(500)
        Try
            If Psc.Count > 0 Then
                For Each p As ParallaxServoController In Psc
                    If p.IsSerialPortOpen Then
                        p.CloseSerialPort()
                    End If
                Next
            End If
        Catch ex As UnauthorizedAccessException
            MessageBox.Show("Unexpected Serial port disconnection")
        Catch ex As Exception
            MessageBox.Show("Unexpected error in CleanUp")
        End Try

    End Sub 'CleanUp


    Private Sub ArmForm_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        CleanUp()
    End Sub


    Delegate Sub SetHighLightCallback(ByVal bool As Boolean, ByVal i As Integer)

    Private Sub Sequence1_HighLightRow(ByVal sender As Object, ByVal e As BuisnessLogicLayer.SequenceEventArgs) Handles Sequence1.HighLightRow
        Dim i As Integer
        Dim row As DataGridViewRow

        For i = 0 To Me.DataGridView1.RowCount - 1
            row = Me.DataGridView1.Rows(i)
            If row.Cells(0).Value = e.SequenceId Then
                row.Selected = True
            Else
                row.Selected = False
            End If
            'Me.DataGridView1.Update()
        Next

    End Sub


    Private Sub Sequence1_SequenceChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles Sequence1.SequenceChanged
        Dim seq As Sequence
        seq = CType(sender, Sequence)

        Me.DataGridView1.DataSource = seq.JointPositions
    End Sub


    'Create Dynamic channel selection in toolbar
    Private Sub AddPscToChannelMenuItems(ByVal pscs As List(Of ParallaxServoController))
        Dim index As Integer = 0
        Dim pscItem As System.Windows.Forms.ToolStripMenuItem = Nothing
        Me.ChannelsToolStripMenuItem.DropDownItems.Clear()

        For Each psc As ParallaxServoController In pscs
            pscItem = New System.Windows.Forms.ToolStripMenuItem
            pscItem.Name = "PSC_" & psc.Id
            pscItem.Size = New System.Drawing.Size(152, 22)
            pscItem.Text = "PSC (" & psc.Id & ")"
            Me.ChannelsToolStripMenuItem.DropDownItems.Add(pscItem)
            AddChannelMenuItems(pscItem)
        Next
    End Sub


    Private Sub AddChannelMenuItems(ByVal pscItem As System.Windows.Forms.ToolStripMenuItem)
        Dim channelItem As ToolStripMenuItem = Nothing
        Dim i As Integer

        For i = 0 To 31
            channelItem = New System.Windows.Forms.ToolStripMenuItem
            channelItem.Name = "Channel_" & i & "_" & pscItem.Name
            channelItem.Size = New System.Drawing.Size(152, 22)
            channelItem.Text = "Channel " & i
            AddHandler channelItem.Click, AddressOf OnChannelMenuItemClick
            pscItem.DropDownItems.Add(channelItem)
        Next
    End Sub


    Private Sub OnChannelMenuItemClick(ByVal sender As Object, ByVal e As EventArgs)
        Dim selectedChannel As ToolStripMenuItem = CType(sender, ToolStripMenuItem)

        'Get PSC and Channel Item Numbers
        Dim itemArray As String() = Split(selectedChannel.Name, "_")
        Dim channelNum As Integer = CInt(itemArray(1))
        Dim pscNum As Integer = CInt(itemArray(3))

        'Check the menu item
        If selectedChannel.Checked Then
            selectedChannel.Checked = False
            'Remove channel control
            RemoveChannelControl(pscNum, channelNum)
        Else
            selectedChannel.Checked = True
            'Add channel control to form
            Dim chCtrl As PscChannelControl = AddChannelControl(channelNum, pscNum)
            CreateChannel(pscNum, channelNum, chCtrl)
        End If

        UpdateChannelControlGrouping()

    End Sub


    Private Sub AddPscBaudToPscMenuItems(ByVal pscs As List(Of ParallaxServoController))
        Dim index As Integer = 0
        Dim pscItem As System.Windows.Forms.ToolStripMenuItem = Nothing
        Me.PSCToolStripMenuItem.DropDownItems.Clear()

        For Each psc As ParallaxServoController In pscs
            pscItem = New System.Windows.Forms.ToolStripMenuItem
            pscItem.Name = "PSC_" & psc.Id
            pscItem.Size = New System.Drawing.Size(152, 22)
            pscItem.Text = "PSC (" & psc.Id & ")"
            Me.PSCToolStripMenuItem.DropDownItems.Add(pscItem)
            AddBaudMenuItems(pscItem, psc)
        Next
    End Sub


    Private Sub AddBaudMenuItems(ByVal pscItem As System.Windows.Forms.ToolStripMenuItem, ByVal psc As ParallaxServoController)
        Dim baudItem As ToolStripMenuItem = Nothing
        pscItem.DropDownItems.Clear()

        baudItem = New System.Windows.Forms.ToolStripMenuItem
        baudItem.Name = "N2400_" & pscItem.Name
        baudItem.Size = New System.Drawing.Size(152, 22)
        baudItem.Text = "N2400"
        If psc.Baud = ParallaxServoController.BaudRate.N2400 Then
            baudItem.Checked = True
        Else
            baudItem.Checked = False
        End If
        AddHandler baudItem.Click, AddressOf OnBaudMenuItemClick
        pscItem.DropDownItems.Add(baudItem)


        baudItem = New System.Windows.Forms.ToolStripMenuItem
        baudItem.Name = "N38k4_" & pscItem.Name
        baudItem.Size = New System.Drawing.Size(152, 22)
        baudItem.Text = "N38k4"
        If psc.Baud = ParallaxServoController.BaudRate.N38k4 Then
            baudItem.Checked = True
        Else
            baudItem.Checked = False
        End If
        AddHandler baudItem.Click, AddressOf OnBaudMenuItemClick
        pscItem.DropDownItems.Add(baudItem)

    End Sub


    Private Sub OnBaudMenuItemClick(ByVal sender As Object, ByVal e As EventArgs)
        Dim selectedBaud As ToolStripMenuItem = CType(sender, ToolStripMenuItem)

        'Get PSC and Baud and PSC index
        Dim itemArray As String() = Split(selectedBaud.Name, "_")
        Dim BaudNum As String = CStr(itemArray(0))
        Dim pscNum As Integer = CInt(itemArray(2))

        If Not selectedBaud.Checked Then
            If Psc(pscNum).Baud = BaudRate.N38k4 Then
                Psc(pscNum).SetBaud(BaudRate.N2400)
            Else
                Psc(pscNum).SetBaud(BaudRate.N38k4)
            End If
        End If

        'Update baud dropdown menu
        AddPscBaudToPscMenuItems(Psc)
        'Update StatusStrip
        Dim str As String = Nothing
        For Each p As ParallaxServoController In Psc
            str = str & p.ToString
        Next
        Me.lblComPort.Text = str
        Me.StatusStrip1.Update()
    End Sub


    Private Sub RemoveChannelControl(ByVal pscNum As String, ByVal channelNum As String)
        Dim chName As String = "PscChannelControl" & pscNum & channelNum
        Dim chCtrl As PscChannelControl = Nothing
        Dim dataSource As PscChannel = Nothing

        If Not Psc Is Nothing Then
            For Each pcc As PscChannelControl In channelControls
                If pcc.Name = chName Then
                    chCtrl = pcc
                    dataSource = pcc.DataSource
                End If
            Next
        End If

        'Remove control
        channelControls.Remove(chCtrl)
        chCtrl.Dispose()
        'Remove channel element from Psc object
        Psc(CInt(pscNum)).Channel.Remove(dataSource)

    End Sub


    Private Function AddChannelControl(ByVal channelNum As String, ByVal pscNum As Integer) As PscChannelControl
        Dim pscCtrl As New CrustCrawler.PscChannelControl

        pscCtrl.Changed = False
        pscCtrl.Location = New System.Drawing.Point(150, 150)
        pscCtrl.Name = "PscChannelControl" & pscNum & channelNum
        pscCtrl.Padding = New System.Windows.Forms.Padding(1)
        pscCtrl.Size = New System.Drawing.Size(144, 124)
        pscCtrl.TabIndex = 1

        'Add channel control to array and panel collection
        channelControls.Add(pscCtrl)
        Me.SplitContainer1.Panel1.Controls.Add(pscCtrl)

        'Add handlers
        AddHandler pscCtrl.ControlMoved, AddressOf OnChannelMove
        AddHandler pscCtrl.Group, AddressOf OnChannelGroup
        AddHandler pscCtrl.UnGroup, AddressOf OnChannelUngroup
        AddHandler pscCtrl.StateChanged, AddressOf OnStateChanged
        Return pscCtrl
    End Function

    Private Function AddChannelControl(ByVal channelNum As String, ByVal pscNum As Integer, ByVal location As Point) As PscChannelControl
        Dim pscCtrl As New CrustCrawler.PscChannelControl

        pscCtrl.Changed = False
        pscCtrl.Location = New System.Drawing.Point(location.X, location.Y)
        pscCtrl.Name = "PscChannelControl" & pscNum & channelNum
        pscCtrl.Padding = New System.Windows.Forms.Padding(1)
        pscCtrl.Size = New System.Drawing.Size(144, 124)
        pscCtrl.TabIndex = 1

        'Add channel control to array and panel collection
        channelControls.Add(pscCtrl)
        Me.SplitContainer1.Panel1.Controls.Add(pscCtrl)

        'Add handlers
        AddHandler pscCtrl.ControlMoved, AddressOf OnChannelMove
        AddHandler pscCtrl.Group, AddressOf OnChannelGroup
        AddHandler pscCtrl.UnGroup, AddressOf OnChannelUngroup
        AddHandler pscCtrl.StateChanged, AddressOf OnStateChanged
        Return pscCtrl
    End Function

    'Handle the individual channel control grouping dropdown menus
    'Only display grouped channel in parent control.
    'If a channel has children then show the channels as checked
    Private Sub UpdateChannelControlGrouping()

        Dim channelStrs As New List(Of String)
        Dim groupItem As ToolStripMenuItem = Nothing

        'Grab all the onscreen control that are not grouped
        'and put there names into a string array
        For Each cc As PscChannelControl In channelControls
            cc.tsdbGroup.DropDownItems.Clear()
            If cc.DataSource.GetType.Name = "PscChannel" Then
                channelStrs.Add(cc.DataSource.PscId & "_" & cc.ChannelId)
            End If
        Next

        'Add the visible channels to the individual group 
        'toolbar dropdowns.  Do not add self to the group list
        For Each cc As PscChannelControl In channelControls
            For Each str As String In channelStrs
                If cc.DataSource.PscId & "_" & cc.ChannelId <> str Then
                    Dim ids() As String = Split(str, "_")
                    groupItem = New ToolStripMenuItem
                    groupItem.Name = String.Format("PSC_{0}_Channel_{1}", ids(0), ids(1))
                    groupItem.Size = New System.Drawing.Size(152, 22)
                    groupItem.Text = String.Format("PSC({0}) Channel {1}", ids(0), ids(1))
                    cc.tsdbGroup.DropDownItems.Add(groupItem)
                    AddHandler groupItem.Click, AddressOf cc.OnGroupMenuItemClick
                End If
            Next
        Next

        'Checkmark the channels that are children of in the individual 
        '(control) group dropdowns
        For Each cc As PscChannelControl In channelControls
            If cc.DataSource.GetType.Name = "PeerChannel" Then

                Dim pc As PeerChannel = CType(cc.DataSource, PeerChannel)
                Dim childItem As ToolStripMenuItem = Nothing

                For Each c As PeerChannel In pc.ChildChannels
                    childItem = New ToolStripMenuItem
                    childItem.Name = String.Format("PSC_{0}_Channel_{1}", c.PscId, c.ChannelId)
                    '"Channel_" & c.ChannelId
                    childItem.Size = New System.Drawing.Size(152, 22)
                    childItem.Text = String.Format("PSC({0}) Channel {1}", c.PscId, c.ChannelId)
                    childItem.Checked = True
                    AddHandler childItem.Click, AddressOf cc.OnGroupMenuItemClick
                    cc.tsdbGroup.DropDownItems.Add(childItem)
                Next
            End If
        Next

        'Sort the group list in ascending order
        For Each cc As PscChannelControl In channelControls
            Dim menuItems(cc.tsdbGroup.DropDownItems.Count - 1) As ToolStripMenuItem
            cc.tsdbGroup.DropDownItems.CopyTo(menuItems, 0)
            System.Array.Sort(menuItems, New ChannelComparer)
            cc.tsdbGroup.DropDownItems.Clear()
            cc.tsdbGroup.DropDownItems.AddRange(menuItems)
        Next
    End Sub


#Region " IComapare "

    Private NotInheritable Class ChannelComparer : Implements IComparer
        Public Function Compare(ByVal x As Object, ByVal y As Object) As Integer Implements IComparer.Compare
            Dim first As String = CType(x, ToolStripMenuItem).Name
            Dim second As String = CType(y, ToolStripMenuItem).Name

            Dim tempString() As String = first.Split("_")
            first = tempString(1) & tempString(3)
            tempString = second.Split("_")
            second = tempString(1) & tempString(3)

            Return CInt(first) - CInt(second)
        End Function 'Compare
    End Class 'ChannelComparer

#End Region


    Private Sub OnChannelMove(ByVal sender As Object, ByVal e As EventArgs)
        'Me.lblResults.Text = CType(sender, PscChannelControl).Location.ToString
        'Me.lblResults.Update()
        Me.Project1.OnUpdateProject(Psc, channelControls)
    End Sub


    'Main form dropdown
    Private Sub OnChannelGroup(ByVal sender As Object, ByVal e As PscChannelEventArgs)

        Dim channelId As Integer = CInt(e.Channel(3))
        Dim pscId As Integer = CInt(e.Channel(1))
        Dim channelName As String = "PscChannelControl" & pscId & channelId
        Dim master As PscChannel = CType(sender, PscChannelControl).DataSource
        Dim child As PscChannel = Nothing

        'TODO: Problem with Control reference - Its the PscChannelEventArgs - Ahhhhh
        ' You need to fix the refreence to the controls!!!
        'Remove pscChannel from generic collection
        For Each cc As PscChannelControl In channelControls
            If cc.Name = channelName Then
                child = cc.DataSource
                channelControls.Remove(cc)
                cc.Dispose()
                Exit For
            End If
        Next

        'Determine if the control is already grouped
        If master.GetType.Name = "PscChannel" Then
            'Create new group
            Dim peerSource As PeerChannel = Psc(master.PscId).CreatePeerGroup(master, child)
            CType(sender, PscChannelControl).BindChannel(peerSource)
        Else
            'Add to group
            Psc(master.PscId).AddPeerChild(master, child)
        End If

        'Update grouping drop down
        UpdateChannelControlGrouping()

        'Disable main dropdown list item if the object is a child (grouped)
        Dim channelMenu As ToolStripMenuItem = Me.ChannelsToolStripMenuItem
        Dim pscMenu As ToolStripItemCollection = channelMenu.DropDownItems
        Dim pm As ToolStripMenuItem = pscMenu.Item(master.PscId)
        pm.DropDownItems(child.ChannelId).Enabled = False
        pm.DropDownItems(master.ChannelId).Enabled = False

        Me.Project1.OnUpdateProject(Psc, channelControls)
    End Sub


    Private Sub OnStateChanged(ByVal sender As Object, ByVal e As System.EventArgs)
        Me.Project1.OnUpdateProject(Psc, channelControls)
    End Sub


    'Main form dropdown
    Private Sub OnChannelUngroup(ByVal sender As Object, ByVal e As PscChannelEventArgs)
        Dim channelControl As PscChannelControl = CType(sender, PscChannelControl)
        Dim source As PscChannel = channelControl.DataSource

        'Convert peerChannel to pscChannel if the object does not have children
        If source.GetType.Name = "PeerChannel" Then
            If CType(source, PeerChannel).ChildChannels.Count = 0 Then
                'Convert master from PeerChannel to PscChannel
                Dim ch As PscChannel = Psc(e.ChannelObject.PscId).CreateNewChannel(source.ChannelId)
                'Save current settings and bind to usercontrol
                ch.Max = source.Max
                ch.Min = source.Min
                ch.position = source.position
                ch.Ramp = source.Ramp
                ch.Inverse = source.Inverse
                ch.Delay = source.Delay
                ch.Grouped = source.Grouped
                channelControl.BindChannel(ch)
            Else
                channelControl.BindChannel(CType(channelControl.DataSource, PscChannel))
            End If
        End If
        'Split child channel from master
        Dim pcc As PscChannelControl = AddChannelControl(e.ChannelObject.ChannelId, e.ChannelObject.PscId)
        CreateChannel(e.ChannelObject.PscId, e.Channel(3), pcc)
        With pcc.DataSource
            .Max = e.ChannelObject.Max
            .Min = e.ChannelObject.Min
            .position = e.ChannelObject.position
            .Ramp = e.ChannelObject.Ramp
            '.Inverse = e.ChannelObject.Inverse
            .Inverse = False
            .Delay = e.ChannelObject.Delay
            .Grouped = e.ChannelObject.Grouped
        End With

        UpdateChannelControlGrouping()

        'Enable channel menu item after ungrouping
        Dim channelMenu As ToolStripMenuItem = Me.ChannelsToolStripMenuItem
        Dim pscMenu As ToolStripItemCollection = channelMenu.DropDownItems
        Dim pm As ToolStripMenuItem = pscMenu.Item(0)
        pm.DropDownItems(e.ChannelObject.ChannelId).Enabled = True
        If channelControl.DataSource.GetType.Name = "PeerChannel" Then
            pm.DropDownItems(source.ChannelId).Enabled = False
        Else
            pm.DropDownItems(source.ChannelId).Enabled = True
        End If

        Me.Project1.OnUpdateProject(Psc, channelControls)

    End Sub


    'Load project file and update GUI
    'Updates the toolbar dropdowns
    Private Sub Project1_LoadProject(ByVal sender As Object, ByVal e As System.EventArgs) Handles Project1.LoadProject
        'For Each ch As PscChannelControl In channelControls
        '    channelControls.Clear()
        'Next

        Dim proj As Project = CType(sender, Project)
        Dim pscChannelTable As DataTable = proj.PscChannel
        Dim row As Project.PscChannelRow

        Dim cRow As Project.PscChildChannelRow
        Dim cRows() As Project.PscChildChannelRow
        Try
            For Each row In pscChannelTable.Rows
                Dim channel As New PscChannel(row.ChannelId, row.PscId, row.Max, row.Min, row.Position, row.Ramp, row.Inverse, row.Delay, row.Grouped)
                Dim newChannelControl As PscChannelControl = AddChannelControl(row.ChannelId, row.PscId, New Point(row.LocationX, row.LocationY))
                CreateChannel(row.PscId, channel, newChannelControl)
                cRows = row.GetPscChildChannelRows
                If cRows.Length > 0 Then
                    Dim childChannel As PscChannel
                    For Each cRow In cRows
                        'Create new
                        childChannel = New PscChannel(cRow.ChannelId, cRow.PscId, cRow.Max, cRow.Min, cRow.Position, cRow.Ramp, cRow.Inverse, cRow.Delay, cRow.Grouped)
                        'add to group or create a new group and bind to a control
                        If newChannelControl.DataSource.GetType.Name = "PeerChannel" Then
                            Psc(row.PscId).AddPeerChild(newChannelControl.DataSource, childChannel)
                        Else
                            newChannelControl.BindChannel(Psc(row.PscId).CreatePeerGroup(channel, childChannel))
                        End If
                        'Disable main dropdown list item if the object is a child (grouped)
                        Dim cChannelMenu As ToolStripMenuItem = Me.ChannelsToolStripMenuItem
                        Dim cPscMenu As ToolStripItemCollection = cChannelMenu.DropDownItems
                        Dim cpm As ToolStripMenuItem = cPscMenu.Item(CInt(row.PscId))
                        Dim cChannelMenuItem As ToolStripMenuItem = cpm.DropDownItems(CInt(cRow.ChannelId))
                        cChannelMenuItem.Checked = True
                        cChannelMenuItem.Enabled = False
                    Next
                End If
                'Disable main dropdown list item if the object is a child (grouped)
                'TODO: Fix main dropdown menu
                Dim channelMenu As ToolStripMenuItem = Me.ChannelsToolStripMenuItem
                Dim pscMenu As ToolStripItemCollection = channelMenu.DropDownItems
                Dim pm As ToolStripMenuItem = pscMenu.Item(CInt(row.PscId))
                Dim channelMenuItem As ToolStripMenuItem = pm.DropDownItems(CInt(row.ChannelId))
                channelMenuItem.Checked = True
                If newChannelControl.DataSource.GetType.Name = "PeerChannel" Then
                    channelMenuItem.Enabled = False
                Else
                    channelMenuItem.Enabled = True
                End If

            Next
        Catch ex As Exception
            MessageBox.Show("Error loading project file!" & vbCrLf & ex.ToString)
        End Try
        UpdateChannelControlGrouping()
    End Sub

    Private Sub SetPscBaud(ByVal proj As Project.PscDataTable)
        Dim pscSetting As Project.PscRow

        For Each pscSetting In proj
            If pscSetting.Baud = "2400" Then
                Psc(pscSetting.PscId).SetBaud(BaudRate.N2400)
            Else
                Psc(pscSetting.PscId).SetBaud(BaudRate.N38k4)
            End If
        Next
    End Sub


    Private Sub Add_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AddButton.Click
        Dim chControl As PscChannelControl
        Dim ch As New List(Of PscChannel)
        Dim delay As Integer = IIf(Me.txtSequenceDelay.Text = "", 1, Me.txtSequenceDelay.Text)
        Dim flag As Boolean = False

        For Each chControl In channelControls
            If chControl.Changed Then
                ch.Add(chControl.DataSource)
                chControl.Changed = False
                flag = True
            End If
        Next

        If flag Then
            Me.Sequence1.Add(delay, ch)
        End If
    End Sub


    Private Sub Update_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles UpdateButton.Click
        Dim delay As Integer = IIf(Me.txtSequenceDelay.Text = "", 1, Me.txtSequenceDelay.Text)
        Try
            Dim pc As List(Of PscChannel) = GetPscChannelsFromControls()
            If pc.Count > 0 Then
                Sequence1.Update(CInt(Me.txtSequenceSelector.Text) - 1, delay, pc)
            End If

        Catch ex As Exception
            MessageBox.Show("Enter a record number!")
            Me.txtSequenceSelector.Focus()
        End Try
    End Sub

    Private Sub Delete_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles DeleteButton.Click
        Try
            Dim record As Integer = IIf(Me.txtSequenceSelector.Text.Length > 0, CInt(Me.txtSequenceSelector.Text), 0)
            Sequence1.Delete(record)
        Catch ex As Exception
            MessageBox.Show("Enter a record number!")
            Me.txtSequenceSelector.Focus()
        End Try
    End Sub


    Private Sub Run_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RunButton.Click
        Try

            If Me.BackgroundWorker1.IsBusy Then
                Me.BackgroundWorker1.CancelAsync()
            Else
                Me.RunButton.Image.RotateFlip(RotateFlipType.Rotate90FlipNone)
                Me.BackgroundWorker1.RunWorkerAsync()
            End If

        Catch ex As ArgumentOutOfRangeException
            MessageBox.Show("Sequence / Project mismatch.")
        Catch ex As Exception
            MessageBox.Show("Error Executing sequence.")
        End Try
    End Sub


    Private Sub RunButtonFlipper(ByVal proc As Boolean)
        If proc Then
            RunButton.Image.RotateFlip(RotateFlipType.Rotate90FlipNone)
        Else
            RunButton.Image.RotateFlip(RotateFlipType.Rotate270FlipNone)
        End If
        SequenceToolStrip.Update()
    End Sub


    'Helper function to return PscChannel base object
    Private Function GetPscChannelsFromControls() As List(Of PscChannel)
        Dim pc As New List(Of PscChannel)

        For Each pcc As PscChannelControl In channelControls
            If pcc.Changed Then
                pc.Add(pcc.DataSource)
                pcc.Changed = False
            End If
        Next
        Return pc
    End Function


    Private Sub Sequence1_RecordChanged(ByVal sender As Object, ByVal e As BuisnessLogicLayer.SequenceEventArgs) Handles Sequence1.RecordChanged
        Me.txtSequenceDelay.Text = e.SequenceDelay
        'TODO: Fix threading error here!
        'Me.SequenceToolStrip.Update()
    End Sub


    Private Sub Sequence1_SortGrid(ByVal sender As Object, ByVal e As System.EventArgs) Handles Sequence1.SortGrid
        Me.DataGridView1.Sort(Me.DataGridView1.Columns(0), System.ComponentModel.ListSortDirection.Ascending)
    End Sub

    Private Sub ResetToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ResetToolStripMenuItem.Click
        If MessageBox.Show(String.Format("This action with reestablish PSC connections and remove connectivity to all PSC channels!{0}{0}Are you sure?", vbCrLf), "Reset", MessageBoxButtons.OKCancel) = Windows.Forms.DialogResult.OK Then
            Try
                For Each pcc As PscChannelControl In channelControls
                    pcc.Dispose()
                Next
                channelControls.Clear()
                CleanUp()
                GetPSC()
                Thread.Sleep(500)
                'AddTestChannels()
                If Psc.Count > 0 Then
                    AddPscToChannelMenuItems(Psc)
                    AddPscBaudToPscMenuItems(Psc)
                End If
            Catch ex As UnauthorizedAccessException
                'Cable unplugged?
            Catch ex As Exception
                MessageBox.Show("Error finding PSC")
            End Try
        End If
    End Sub


    Private Sub OpenToolStripMenuItem_Click(ByVal sender As Object, ByVal e As System.EventArgs)
        OpenProject()
    End Sub

    Private Sub OpenProject()
        'Dim myStream As Stream
        For Each pcc As PscChannelControl In channelControls
            pcc.Dispose()
        Next
        channelControls.Clear()

        Dim filePath As String
        filePath = Path.Combine(GetFolderPath(SpecialFolder.ApplicationData), Application.CompanyName)
        filePath = Path.Combine(filePath, Application.ProductName)
        Directory.CreateDirectory(filePath)
        OpenFileDialog1.InitialDirectory = filePath
        Try

            If OpenFileDialog1.ShowDialog() = DialogResult.OK Then
                If Psc.Count > 0 Then
                    Me.Project1.LoadXmlData(OpenFileDialog1.FileName)
                Else
                    MessageBox.Show("Error opening file!" & vbCrLf & "No PSC found - check your connections")
                End If
            End If
        Catch ex As Exception
            MessageBox.Show("Error opening file!" & vbCrLf & "Possible cause - no PSC found")
        End Try
    End Sub

    Private Sub OpenProject(ByVal str As String)
        'Dim myStream As Stream
        For Each pcc As PscChannelControl In channelControls
            pcc.Dispose()
        Next

        Me.Project1.LoadXmlData(str)

    End Sub


    Private Sub OpenSequnceToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        OpenSequence()
    End Sub

    Private Sub OpenSequence()
        Dim filePath As String
        filePath = Path.Combine(GetFolderPath(SpecialFolder.ApplicationData), Application.CompanyName)
        filePath = Path.Combine(filePath, Application.ProductName)
        Directory.CreateDirectory(filePath)
        OpenFileDialog1.InitialDirectory = filePath
        Try
            If OpenFileDialog1.ShowDialog() = DialogResult.OK Then
                Me.Sequence1.LoadXmlData(OpenFileDialog1.FileName)
            End If
        Catch ex As Exception
            MessageBox.Show("Error saving file!")
        End Try
    End Sub

    Private Sub OpenSequence(ByVal str As String)
        Me.Sequence1.LoadXmlData(str)
    End Sub


    Private Sub RepeatToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Dim repeat As ToolStripMenuItem = CType(sender, ToolStripMenuItem)
        If repeat.Checked Then
            repeat.Checked = False
        Else
            repeat.Checked = True
        End If

    End Sub


    Private Sub BackgroundWorker1_DoWork(ByVal sender As Object, ByVal e As System.ComponentModel.DoWorkEventArgs) Handles BackgroundWorker1.DoWork
        Dim record As String = IIf(Me.txtSequenceSelector.Text.Length > 0, Me.txtSequenceSelector.Text, String.Empty)
        Dim pc As New List(Of PscChannel)

        'BackgroundWorker reference casted from the sender parameter.
        Dim bw As BackgroundWorker = CType(sender, BackgroundWorker)

        Try
            'Get control datasources
            For Each pcc As PscChannelControl In channelControls
                pc.Add(pcc.DataSource)
            Next
            'Do while not canceled
            While Not Me.BackgroundWorker1.CancellationPending
                e.Result = Sequence1.ExecuteSequence(record, pc, bw)

                If e.Result = 1 Then
                    bw.CancelAsync()
                    'Throw New Exception("General Error in BackgroundWorker1 process")
                End If
                If Not RepeatToolStripMenuItem.Checked Then
                    bw.CancelAsync()
                End If
            End While

            ' If the operation was canceled by the user, 
            ' set the DoWorkEventArgs.Cancel property to true.
            If bw.CancellationPending Then
                e.Cancel = True
            End If

        Catch ex As Exception
            MessageBox.Show(ex.ToString)
        End Try

    End Sub


    Private Sub BackgroundWorker1_RunWorkerCompleted(ByVal sender As Object, ByVal e As System.ComponentModel.RunWorkerCompletedEventArgs) Handles BackgroundWorker1.RunWorkerCompleted
        If e.Cancelled Then
            ' The user canceled the operation.
            'MessageBox.Show("Operation was canceled")

        ElseIf (e.Error IsNot Nothing) Then
            ' There was an error during the operation.
            'Dim msg As String = String.Format("An error occurred: {0}", e.Error.Message)
            'MessageBox.Show(msg)
        Else
            ' The operation completed normally.
            'Dim msg As String = String.Format("Result = {0}", e.Result)
            'MessageBox.Show(msg)
        End If
        Me.RunButton.Image.RotateFlip(RotateFlipType.Rotate270FlipNone)
        Me.RunButton.Select()

        For Each ch As PscChannelControl In channelControls
            ch.Changed = False
        Next
    End Sub

    Private Sub ClearToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ClearToolStripMenuItem.Click
        If Me.BackgroundWorker1.IsBusy Then
            Me.BackgroundWorker1.CancelAsync()
        End If
        Me.Sequence1.Clear()
        Me.Sequence1.Reset()
    End Sub



    Private Sub ProjectToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ProjectToolStripMenuItem.Click
        OpenProject()
    End Sub

    Private Sub SequenceToolStripMenuItem1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SequenceToolStripMenuItem1.Click
        OpenSequence()
    End Sub

    Private Sub ProjectToolStripMenuItem1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ProjectToolStripMenuItem1.Click
        'Dim myStream As Stream
        Dim filePath As String
        filePath = Path.Combine(GetFolderPath(SpecialFolder.ApplicationData), Application.CompanyName)
        filePath = Path.Combine(filePath, Application.ProductName)
        Directory.CreateDirectory(filePath)
        SaveFileDialog1.InitialDirectory = filePath
        SaveFileDialog1.Filter = "XML files|*.xml"
        SaveFileDialog1.FileName = "*.xml"

        If SaveFileDialog1.ShowDialog() = DialogResult.OK Then
            If InStr(SaveFileDialog1.FileName, ".xml") Then
                Me.Project1.WriteToFile(SaveFileDialog1.FileName)
            Else
                Me.Project1.WriteToFile(SaveFileDialog1.FileName & ".xml")
            End If
        End If
    End Sub

    Private Sub SequenceToolStripMenuItem2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SequenceToolStripMenuItem2.Click
        Dim filePath As String
        filePath = Path.Combine(GetFolderPath(SpecialFolder.ApplicationData), Application.CompanyName)
        filePath = Path.Combine(filePath, Application.ProductName)
        Directory.CreateDirectory(filePath)
        SaveFileDialog1.InitialDirectory = filePath
        SaveFileDialog1.Filter = "XML files|*.xml"
        SaveFileDialog1.FileName = "*.xml"

        If SaveFileDialog1.ShowDialog() = DialogResult.OK Then
            If InStr(SaveFileDialog1.FileName, ".xml") Then
                Me.Sequence1.WriteToFile(SaveFileDialog1.FileName)
            Else
                Me.Sequence1.WriteToFile(SaveFileDialog1.FileName & ".xml")
            End If
        End If
    End Sub

    Private Sub ExportToSTAMPToolStripMenuItem1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExportToSTAMPToolStripMenuItem1.Click
        Dim records As String = IIf(Me.txtSequenceSelector.Text.Length > 0, Me.txtSequenceSelector.Text, String.Empty)
        Dim pc As New List(Of PscChannel)

        Try
            Dim export As ExportToStamp = Sequence1.ExecuteEepromExport(records, channelControls)

            Dim filePath As String
            filePath = Path.Combine(GetFolderPath(SpecialFolder.ApplicationData), Application.CompanyName)
            filePath = Path.Combine(filePath, Application.ProductName)
            Directory.CreateDirectory(filePath)
            SaveFileDialog1.InitialDirectory = filePath
            SaveFileDialog1.Filter = "STAMP files|*.bs2"
            SaveFileDialog1.FileName = "*.bs2"

            If SaveFileDialog1.ShowDialog() = DialogResult.OK Then
                If InStr(SaveFileDialog1.FileName, ".bs2") Then
                    export.CreateExport(SaveFileDialog1.FileName)
                Else
                    export.CreateExport(SaveFileDialog1.FileName & ".bs2")
                End If
            End If

        Catch ex As Exception
            MessageBox.Show(ex.ToString)
            'MessageBox.Show("Export error!")
        End Try
    End Sub

    'Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click

    '    Dim pc As New List(Of PeerChannel)

    '    For Each c As PscChannelControl In channelControls
    '        pc.Add(CType(c.DataSource, PeerChannel))
    '    Next

    'End Sub
End Class